package javax.xml.crypto.dsig;

import javax.xml.crypto.KeySelectorResult;
import javax.xml.crypto.MarshalException;
import java.util.List;
import javax.xml.crypto.dsig.keyinfo.KeyInfo;
import javax.xml.crypto.XMLStructure;

public interface XMLSignature extends XMLStructure
{
    public static final String XMLNS = "http://www.w3.org/2000/09/xmldsig#";
    
    public abstract boolean validate(XMLValidateContext p0) throws XMLSignatureException;
    
    public abstract KeyInfo getKeyInfo();
    
    public abstract SignedInfo getSignedInfo();
    
    public abstract List getObjects();
    
    public abstract String getId();
    
    public abstract XMLSignature.SignatureValue getSignatureValue();
    
    public abstract void sign(XMLSignContext p0) throws MarshalException, XMLSignatureException;
    
    public abstract KeySelectorResult getKeySelectorResult();
    
    public interface SignatureValue extends XMLStructure
    {
        public abstract String getId();
        
        public abstract byte[] getValue();
        
        public abstract boolean validate(XMLValidateContext p0) throws XMLSignatureException;
    }
}
